## API Report File for "@azure/arm-webservices"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import * as coreAuth from '@azure/core-auth';
import * as coreClient from '@azure/core-client';
import { PagedAsyncIterableIterator } from '@azure/core-paging';
import { PollerLike } from '@azure/core-lro';
import { PollOperationState } from '@azure/core-lro';

// @public
export interface AssetItem {
    id?: string;
    inputPorts?: {
        [propertyName: string]: InputPort;
    };
    locationInfo: BlobLocation;
    metadata?: {
        [propertyName: string]: string;
    };
    name: string;
    outputPorts?: {
        [propertyName: string]: OutputPort;
    };
    parameters?: ModuleAssetParameter[];
    type: AssetType;
}

// @public
export type AssetType = string;

// @public
export interface AsyncOperationErrorInfo {
    readonly code?: string;
    readonly details?: AsyncOperationErrorInfo[];
    readonly message?: string;
    readonly target?: string;
}

// @public
export interface AsyncOperationStatus {
    readonly endTime?: Date;
    readonly errorInfo?: AsyncOperationErrorInfo;
    readonly id?: string;
    readonly name?: string;
    readonly percentComplete?: number;
    readonly provisioningState?: ProvisioningState;
    readonly startTime?: Date;
}

// @public (undocumented)
export class AzureMLWebServicesManagementClient extends coreClient.ServiceClient {
    // (undocumented)
    $host: string;
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: AzureMLWebServicesManagementClientOptionalParams);
    // (undocumented)
    apiVersion: string;
    // (undocumented)
    operations: Operations;
    // (undocumented)
    subscriptionId: string;
    // (undocumented)
    webServices: WebServices;
}

// @public
export interface AzureMLWebServicesManagementClientOptionalParams extends coreClient.ServiceClientOptions {
    $host?: string;
    apiVersion?: string;
    endpoint?: string;
}

// @public
export interface BlobLocation {
    credentials?: string;
    uri: string;
}

// @public
export type ColumnFormat = string;

// @public
export interface ColumnSpecification {
    enum?: Record<string, unknown>[];
    format?: ColumnFormat;
    type: ColumnType;
    xMsIsnullable?: boolean;
    xMsIsordered?: boolean;
}

// @public
export type ColumnType = string;

// @public
export interface CommitmentPlan {
    id: string;
}

// @public
export interface DiagnosticsConfiguration {
    expiry?: Date;
    level: DiagnosticsLevel;
}

// @public
export type DiagnosticsLevel = string;

// @public
export interface ExampleRequest {
    globalParameters?: {
        [propertyName: string]: Record<string, unknown>;
    };
    inputs?: {
        [propertyName: string]: Record<string, unknown>[][];
    };
}

// @public
export function getContinuationToken(page: unknown): string | undefined;

// @public
export interface GraphEdge {
    sourceNodeId?: string;
    sourcePortId?: string;
    targetNodeId?: string;
    targetPortId?: string;
}

// @public
export interface GraphNode {
    assetId?: string;
    inputId?: string;
    outputId?: string;
    parameters?: {
        [propertyName: string]: WebServiceParameter;
    };
}

// @public
export interface GraphPackage {
    edges?: GraphEdge[];
    graphParameters?: {
        [propertyName: string]: GraphParameter;
    };
    nodes?: {
        [propertyName: string]: GraphNode;
    };
}

// @public
export interface GraphParameter {
    description?: string;
    links: GraphParameterLink[];
    type: ParameterType;
}

// @public
export interface GraphParameterLink {
    nodeId: string;
    parameterKey: string;
}

// @public
export interface InputPort {
    type?: InputPortType;
}

// @public
export type InputPortType = string;

// @public
export enum KnownAssetType {
    Module = "Module",
    Resource = "Resource"
}

// @public
export enum KnownColumnFormat {
    Byte = "Byte",
    Char = "Char",
    Complex128 = "Complex128",
    Complex64 = "Complex64",
    DateTime = "Date-time",
    DateTimeOffset = "Date-timeOffset",
    Double = "Double",
    Duration = "Duration",
    Float = "Float",
    Int16 = "Int16",
    Int32 = "Int32",
    Int64 = "Int64",
    Int8 = "Int8",
    Uint16 = "Uint16",
    Uint32 = "Uint32",
    Uint64 = "Uint64",
    Uint8 = "Uint8"
}

// @public
export enum KnownColumnType {
    Boolean = "Boolean",
    Integer = "Integer",
    Number = "Number",
    String = "String"
}

// @public
export enum KnownDiagnosticsLevel {
    All = "All",
    Error = "Error",
    None = "None"
}

// @public
export enum KnownInputPortType {
    Dataset = "Dataset"
}

// @public
export enum KnownOutputPortType {
    Dataset = "Dataset"
}

// @public
export enum KnownParameterType {
    Boolean = "Boolean",
    ColumnPicker = "ColumnPicker",
    Credential = "Credential",
    DataGatewayName = "DataGatewayName",
    Double = "Double",
    Enumerated = "Enumerated",
    Float = "Float",
    Int = "Int",
    Mode = "Mode",
    ParameterRange = "ParameterRange",
    Script = "Script",
    String = "String"
}

// @public
export enum KnownProvisioningState {
    Failed = "Failed",
    Provisioning = "Provisioning",
    Succeeded = "Succeeded",
    Unknown = "Unknown"
}

// @public
export interface MachineLearningWorkspace {
    id: string;
}

// @public
export interface ModeValueInfo {
    interfaceString?: string;
    parameters?: ModuleAssetParameter[];
}

// @public
export interface ModuleAssetParameter {
    modeValuesInfo?: {
        [propertyName: string]: ModeValueInfo;
    };
    name?: string;
    parameterType?: string;
}

// @public
export interface OperationDisplayInfo {
    readonly description?: string;
    readonly operation?: string;
    readonly provider?: string;
    readonly resource?: string;
}

// @public
export interface OperationEntity {
    display?: OperationDisplayInfo;
    readonly name?: string;
}

// @public
export interface OperationEntityListResult {
    readonly value?: OperationEntity[];
}

// @public
export interface Operations {
    list(options?: OperationsListOptionalParams): PagedAsyncIterableIterator<OperationEntity>;
}

// @public
export interface OperationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListResponse = OperationEntityListResult;

// @public
export interface OutputPort {
    type?: OutputPortType;
}

// @public
export type OutputPortType = string;

// @public
export interface PaginatedWebServicesList {
    nextLink?: string;
    value?: WebService[];
}

// @public
export type ParameterType = string;

// @public
export interface PatchedResource {
    readonly id?: string;
    readonly location?: string;
    readonly name?: string;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface PatchedWebService extends PatchedResource {
    properties?: WebServicePropertiesUnion;
}

// @public
export type ProvisioningState = string;

// @public
export interface RealtimeConfiguration {
    maxConcurrentCalls?: number;
}

// @public
export interface Resource {
    readonly id?: string;
    location: string;
    readonly name?: string;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface ServiceInputOutputSpecification {
    description?: string;
    properties: {
        [propertyName: string]: TableSpecification;
    };
    title?: string;
    type: string;
}

// @public
export interface StorageAccount {
    key?: string;
    name?: string;
}

// @public
export interface TableSpecification {
    description?: string;
    format?: string;
    properties?: {
        [propertyName: string]: ColumnSpecification;
    };
    title?: string;
    type: string;
}

// @public
export interface WebService extends Resource {
    properties: WebServicePropertiesUnion;
}

// @public
export interface WebServiceKeys {
    primary?: string;
    secondary?: string;
}

// @public
export interface WebServiceParameter {
    certificateThumbprint?: string;
    value?: Record<string, unknown>;
}

// @public
export interface WebServiceProperties {
    assets?: {
        [propertyName: string]: AssetItem;
    };
    commitmentPlan?: CommitmentPlan;
    readonly createdOn?: Date;
    description?: string;
    diagnostics?: DiagnosticsConfiguration;
    exampleRequest?: ExampleRequest;
    exposeSampleData?: boolean;
    input?: ServiceInputOutputSpecification;
    keys?: WebServiceKeys;
    machineLearningWorkspace?: MachineLearningWorkspace;
    readonly modifiedOn?: Date;
    output?: ServiceInputOutputSpecification;
    packageType: "Graph";
    parameters?: {
        [propertyName: string]: WebServiceParameter;
    };
    payloadsInBlobStorage?: boolean;
    payloadsLocation?: BlobLocation;
    readonly provisioningState?: ProvisioningState;
    readOnly?: boolean;
    realtimeConfiguration?: RealtimeConfiguration;
    storageAccount?: StorageAccount;
    readonly swaggerLocation?: string;
    title?: string;
}

// @public
export interface WebServicePropertiesForGraph extends WebServiceProperties {
    package?: GraphPackage;
    packageType: "Graph";
}

// @public (undocumented)
export type WebServicePropertiesUnion = WebServiceProperties | WebServicePropertiesForGraph;

// @public
export interface WebServices {
    beginCreateOrUpdate(resourceGroupName: string, webServiceName: string, createOrUpdatePayload: WebService, options?: WebServicesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<WebServicesCreateOrUpdateResponse>, WebServicesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, webServiceName: string, createOrUpdatePayload: WebService, options?: WebServicesCreateOrUpdateOptionalParams): Promise<WebServicesCreateOrUpdateResponse>;
    beginCreateRegionalProperties(resourceGroupName: string, webServiceName: string, region: string, options?: WebServicesCreateRegionalPropertiesOptionalParams): Promise<PollerLike<PollOperationState<WebServicesCreateRegionalPropertiesResponse>, WebServicesCreateRegionalPropertiesResponse>>;
    beginCreateRegionalPropertiesAndWait(resourceGroupName: string, webServiceName: string, region: string, options?: WebServicesCreateRegionalPropertiesOptionalParams): Promise<WebServicesCreateRegionalPropertiesResponse>;
    beginPatch(resourceGroupName: string, webServiceName: string, patchPayload: PatchedWebService, options?: WebServicesPatchOptionalParams): Promise<PollerLike<PollOperationState<WebServicesPatchResponse>, WebServicesPatchResponse>>;
    beginPatchAndWait(resourceGroupName: string, webServiceName: string, patchPayload: PatchedWebService, options?: WebServicesPatchOptionalParams): Promise<WebServicesPatchResponse>;
    beginRemove(resourceGroupName: string, webServiceName: string, options?: WebServicesRemoveOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginRemoveAndWait(resourceGroupName: string, webServiceName: string, options?: WebServicesRemoveOptionalParams): Promise<void>;
    get(resourceGroupName: string, webServiceName: string, options?: WebServicesGetOptionalParams): Promise<WebServicesGetResponse>;
    listByResourceGroup(resourceGroupName: string, options?: WebServicesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<WebService>;
    listBySubscriptionId(options?: WebServicesListBySubscriptionIdOptionalParams): PagedAsyncIterableIterator<WebService>;
    listKeys(resourceGroupName: string, webServiceName: string, options?: WebServicesListKeysOptionalParams): Promise<WebServicesListKeysResponse>;
}

// @public
export interface WebServicesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type WebServicesCreateOrUpdateResponse = WebService;

// @public
export interface WebServicesCreateRegionalPropertiesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type WebServicesCreateRegionalPropertiesResponse = AsyncOperationStatus;

// @public
export interface WebServicesGetOptionalParams extends coreClient.OperationOptions {
    region?: string;
}

// @public
export type WebServicesGetResponse = WebService;

// @public
export interface WebServicesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
    skiptoken?: string;
}

// @public
export type WebServicesListByResourceGroupNextResponse = PaginatedWebServicesList;

// @public
export interface WebServicesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
    skiptoken?: string;
}

// @public
export type WebServicesListByResourceGroupResponse = PaginatedWebServicesList;

// @public
export interface WebServicesListBySubscriptionIdNextOptionalParams extends coreClient.OperationOptions {
    skiptoken?: string;
}

// @public
export type WebServicesListBySubscriptionIdNextResponse = PaginatedWebServicesList;

// @public
export interface WebServicesListBySubscriptionIdOptionalParams extends coreClient.OperationOptions {
    skiptoken?: string;
}

// @public
export type WebServicesListBySubscriptionIdResponse = PaginatedWebServicesList;

// @public
export interface WebServicesListKeysOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebServicesListKeysResponse = WebServiceKeys;

// @public
export interface WebServicesPatchOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type WebServicesPatchResponse = WebService;

// @public
export interface WebServicesRemoveOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// (No @packageDocumentation comment for this package)

```
